Skip to main content
`Ctrl`+`K`

# Polynomial1D

class astropy.modeling.polynomial.Polynomial1D(degree, domain=None, window=None, n_models=None, model_set_axis=None, name=None, meta=None, **params)

  Bases: `_PolyDomainWindow1D`

  1D Polynomial model.

  It is defined as:

  \[P = \sum_{i=0}^{i=n}C_{i} * x^{i}\]

  For explanation of `domain`, and `window` see Notes regarding usage of domain and window.

  Parameters:
    degree `python:int`

      degree of the series

    domain `python:tuple` or `python:None`, optional

      If None, it is set to (-1, 1)

    window `python:tuple` or `python:None`, optional

      If None, it is set to (-1, 1) Fitters will remap the domain to this window

    **params `python:dict`

      keyword: value pairs, representing parameter_name: value

  Other Parameters:
    fixed `python:dict`, optional

      A dictionary `{parameter_name: boolean}` of parameters to not be varied during fitting. True means the parameter is held fixed. Alternatively the `fixed` property of a parameter may be used.

    tied `python:dict`, optional

      A dictionary `{parameter_name: callable}` of parameters which are linked to some other parameter. The dictionary values are callables providing the linking relationship. Alternatively the `tied` property of a parameter may be used.

    bounds `python:dict`, optional

      A dictionary `{parameter_name: value}` of lower and upper bounds of parameters. Keys are parameter names. Values are a list or a tuple of length 2 giving the desired range for the parameter. Alternatively, the `min` and `max` properties of a parameter may be used.

    eqcons `python:list`, optional

      A list of functions of length `n` such that `eqcons[j](x0,*args) == 0.0` in a successfully optimized problem.

    ineqcons `python:list`, optional

      A list of functions of length `n` such that `ieqcons[j](x0,*args) >= 0.0` is a successfully optimized problem.

  Attributes Summary

  `input_units` | This property is used to indicate what units or sets of units the evaluate method expects, and returns a dictionary mapping inputs to units (or `None` if any units are accepted).
  `n_inputs` |
  `n_outputs` |

  Methods Summary

  `__call__`(*inputs[, model_set_axis, ...]) | Evaluate this model using the given input(s) and the parameter values that were specified when the model was instantiated.
  `evaluate`(x, *coeffs) | Evaluate the model on some input variables.
  `fit_deriv`(x, *params) | Computes the Vandermonde matrix.
  `horner`(x, coeffs) |
  `prepare_inputs`(x, **kwargs) | This method is used in `__call__` to ensure that all the inputs to the model can be broadcast into compatible shapes (if one or both of them are input as arrays), particularly if there are more than one parameter sets.

  Attributes Documentation

  input_units
  n_inputs = 1
  n_outputs = 1

  Methods Documentation

  __call__(*inputs, model_set_axis=None, with_bounding_box=False, fill_value=nan, equivalencies=None, inputs_map=None, **new_inputs)

    Evaluate this model using the given input(s) and the parameter values that were specified when the model was instantiated.

  evaluate(x, *coeffs)

    Evaluate the model on some input variables.

  fit_deriv(x, *params)

    Computes the Vandermonde matrix.

    Parameters:
      x `ndarray`

        input

      *params

        throw-away parameter list returned by non-linear fitters

    Returns:
      result `ndarray`

        The Vandermonde matrix

  static horner(x, coeffs)
  prepare_inputs(x, **kwargs)

    This method is used in `__call__` to ensure that all the inputs to the model can be broadcast into compatible shapes (if one or both of them are input as arrays), particularly if there are more than one parameter sets. This also makes sure that (if applicable) the units of the input will be compatible with the evaluate method.